#!/usr/bin/python3

import http.client, urllib.parse
import json
import re

def format_adress(a):
  sa = a['streetAddress'].split(',')
  street = sa[0].strip()
  city = sa[1].strip()
  return "%s\n%s %s\n%s, %s\n%s" % (a['name'],a['firstName'],a['lastName'],street,city,a['telephone'])

#CoopCycle token
token=''
#
key=''
date='2019-06-17'

# get coopcycle current tasks for specific date
params = urllib.parse.urlencode({})
headers = {"Authorization":"Bearer %s" % (token),"Content-Type":"application/ld+json"}
conn = http.client.HTTPSConnection("lille.coopcycle.org")
conn.request("GET", "/api/tasks?date=%s" % (date), params, headers)
response = conn.getresponse()
tasks_json = json.loads(response.read().decode())
tasks = tasks_json['hydra:member']
conn.close()

# connect to LILLE.BIKE
conn = http.client.HTTPConnection("serveur.kaisser.name")

# get LILLE.BIKE stores list
conn.request("GET", "/lille.bike/index.php/courses/magasins?key=%s" % (key))
response = conn.getresponse()
magasins = json.loads(response.read().decode())

# get all LILLE.BIKE current course to do
conn.request("GET", "/lille.bike//index.php/journal_livraison?key=%s&format=json" % (key))
response = conn.getresponse()
courses = list(filter(lambda c: c['client_ref'][0:2] == 'CC', json.loads(response.read().decode())))

# Get only the pickup task to add
pickups = filter(lambda t: 
    t['type'] == 'PICKUP' and 
    t['status'] == 'TODO'and
    # check if task is not already added
    len(list(filter(lambda c: t['id'] == int(c['client_ref'][2:]), courses))) == 0,
  tasks)

# add tasks to LILLE.BIKE app
for task in pickups:
  # retrieve next task (delevery)
  id_task = int(task['id'])
  id_next = int(task['next'].split('/')[-1:][0])
  next_task = list(filter(lambda t: t['id'] == id_next,tasks))[0]
 
  #retrieve the cliend ID from sotre list
  address_pickup= task['address']
  mag = list(filter(lambda m: m['nom'].lower().strip() == address_pickup['name'].lower().strip(),magasins))[0]
  address_delivery = next_task['address']
  
  print("add task #%d" % id_task)
  
  livr = {}
  
  livr['key'] = key
  livr['donneur_ordre'] = mag['mag_id']
  livr['client'] = mag['client_id']
  
  livr['date'] =  re.split('T|\+',task['doneAfter'])[0]
  livr['heure_debut'] = re.split('T|\+',task['doneAfter'])[1]
  livr['heure_fin'] = re.split('T|\+',next_task['doneBefore'])[1]
  livr['heure_min'] = re.split('T|\+',next_task['doneAfter'])[1]

  livr['delai'] = '4'
  livr['attente'] = '0'
  livr['poids'] = '1'
  livr['valeur'] = '0'
  
  livr['destinataire'] = '-1'
  
  if(task['comments']):
    livr['commentaire'] = task['comments']
  else:
    livr['commentaire'] = ""
  
  # FIX !!
  livr['coursier'] = "1"
  
  livr['commande_ref'] = "CC%i" % id_task
  
  # set adresse dest !!
  if(address_delivery['name']):
    livr['nom'] = address_delivery['name']
    livr['prenom'] = ""
  else:
    livr['nom'] = address_delivery['firstName']
    livr['prenom'] = address_delivery['lastName']
  
  sa = address_delivery['streetAddress'].split(',')
  street = sa[0].strip()
  city = sa[1].strip()
  
  if(street[0].isdigit()):
    sb = street.split(' ')
    livr['adr_num'] = sb[0]
    livr['adr_voie'] =  ' '.join(sb[1:])
  else:
    livr['adr_num'] = 0
    livr['adr_voie'] = street
  
  # FIX !!!
  livr['adr_cp_id'] = 21
  
  if(address_delivery['telephone']):
    livr['tel1'] = address_delivery['telephone']
  else:
    livr['tel1'] = ""
    
  livr['tel2'] = ""
  livr['raison_social'] = ""
  livr['siren'] = ""
  livr['service'] = ""
  
  if(address_delivery['description']):
    livr['adr_cpmt'] = address_delivery['comments']
  else:
    livr['adr_cpmt'] = ""
    
  if(address_delivery['floor']):
    livr['adr_cpmt'] = livr['adr_cpmt'] + "\nEtage : %s" % address_delivery['floor']
  
  headers = {"Content-type": "application/json","Accept": "text/plain"}
  conn.request("POST", "/lille.bike/index.php/courses/ajout_livraison", json.dumps(livr),headers)
  
# bye bye LILLE.BIKE
conn.close()

